Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.C	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.C	(revision 3298)
@@ -13,9 +13,19 @@
 //Current revisions:
 //------------------
-// 
-// 
+/ 
+/ 
 //Former revisions:
 //-----------------
 //$Id: fortran_file.C 2470 2017-09-14 13:56:42Z forkel $
+//  ketelsen 18.09.2018: (Rev 3260) added vector switch and creation of dimension statement
+//  forkel Sept.2018:  'fill_' routine applied to qvap and fakt
+//                      removal of unnecessary variables (LOOKAT, monitor etc. from Fortran code)
+//  forkel June 2018:  Moved adaption to PALM conventions to the end of the process
+//                     in order to make future use of vector code adaptations possible
+//  forkel 20.04.2018: Replace Roundoff = WLAMCH('E') by Roundoff = epsilon(one)
+// 
+// 
+// 
+/ 2017-09-14 13:56:42Z forkel $
 //
 // 
@@ -26,5 +36,5 @@
 //
 //
-// Nov 2016: Intial version (Klaus Ketelsen)
+// Nov 2016: Intial version of KP4 adapted to PALM (Klaus Ketelsen)
 //
 
@@ -62,7 +72,24 @@
      }
 
-// Now do some cosmetics to adapt the KPP generated output a bit o the looks of PALM, 
-// i.e. add some blanks, convert all to lowercase except Fortran language elements, etc.
-       if(line.find("'",0) == string::npos)  {     // No substitution in line with strings
+     if(line.find("'",0) == string::npos)  {     // No substitution in line with strings
+//     if(line.substr(0,4) !="!KPP") {
+//      global_substitute(line,"!"," ! ");
+//     if(line.substr(0,2) =="! ")   continue;           // No Substitute of Comments
+//     global_substitute(line,"("," ( ");
+//     global_substitute(line,")"," ) ");
+//     global_substitute(line,",",", ");
+//     global_substitute(line,"*","* ");
+//     global_substitute(line,"* *","**");
+//     global_substitute(line,"/JVS","/ JVS");
+//     global_substitute(line,"-","- ");
+//     global_substitute(line,"e- ","e-");
+//     global_substitute(line,"+","+ ");
+//     global_substitute(line,"d- ","d-");
+//     global_substitute(line,"D- ","D-");
+//     global_substitute(line,"e+ ","e+");
+//     global_substitute(line,"E+ ","E+");
+//     global_substitute(line,"E- ","E-");
+//      }
+
         if(line.substr(0,2) =="! ") {
          global_substitute(line,"#","#");      // just a dummy so comments do not get lost
@@ -77,48 +104,7 @@
          global_substitute(line,"/JVS","/ JVS");
          global_substitute(line,"-","- ");
-         global_substitute(line,"e- ","e-");
          global_substitute(line,"+","+ ");
          global_substitute(line,"+  ","+ ");
-         global_substitute(line,"d- ","d-");
-         global_substitute(line,"D- ","D-");
-         global_substitute(line,"e+ ","e+");
-         global_substitute(line,"E+ ","E+");
-         global_substitute(line,"E- ","E-");
-         global_substitute(line,")=",") =");
-         global_subtolower(line);
-         global_substitute(line,"call ","CALL ");
-         global_substitute(line,"case","CASE");
-         global_substitute(line,"character","CHARACTER");
-         global_substitute(line,"contains","CONTAINS");
-         global_substitute(line,"dimension","DIMENSION");
-         global_substitute(line,"do ","DO ");
-         global_substitute(line,"elseif","ELSEIF");
-         global_substitute(line,"else","ELSE");
-         global_substitute(line,"#ELSE","#else");
-         global_substitute(line,"end do","ENDDO");
-         global_substitute(line,"end if","ENDIF");
-         global_substitute(line,"end ","END ");    // Modify "end" after all other strings containing "end..." are done!
-         global_substitute(line,"#ENDIF","#endif");
-         global_substitute(line,"function","FUNCTION");
-         global_substitute(line,"if(","IF (");
-         global_substitute(line," if "," IF ");
-         global_substitute(line,"implicit","IMPLICIT");
-         global_substitute(line,"include","INCLUDE");
-         global_substitute(line,"intent","INTENT");
-         global_substitute(line,"integer","INTEGER");
-         global_substitute(line,"logical","LOGICAL");
-         global_substitute(line,"module","MODULE");
-         global_substitute(line,"none","NONE");
-         global_substitute(line,"optional","OPTIONAL");
-         global_substitute(line,"parameter","PARAMETER");
-         global_substitute(line,"public","PUBLIC");
-         global_substitute(line,"real","REAL");
-         global_substitute(line,"return","RETURN");
-         global_substitute(line,"use ","USE ");
-         global_substitute(line,"save","SAVE");
-         global_substitute(line,"subroutine","SUBROUTINE");
-         global_substitute(line,"then","THEN");
-         global_substitute(line,"while","WHILE");
-       }
+         }
      }
 
@@ -167,6 +153,5 @@
 //  Update_RCONST has only to be called once per outer timeloop in KPP_FOR_PALM
 
-//  if(ip->get_token(0) == "CALL" && ip->get_token(1) == "Update_RCONST" ) {
-    if(ip->get_token(0) == "CALL" && ip->get_token(1) == "update_rconst" ) {
+    if(ip->get_token(0) == "CALL" && ip->get_token(1) == "Update_RCONST" ) {
       lo_line.insert(0,"!DELETE ");
     cout << lo_line << endl;
@@ -175,6 +160,12 @@
 //  Update_SUN must not be called within in KPP_FOR_PALM
 
-//  if(ip->get_token(0) == "CALL" && ip->get_token(1) == "Update_SUN" ) {
-    if(ip->get_token(0) == "CALL" && ip->get_token(1) == "update_sun" ) {
+    if(ip->get_token(0) == "CALL" && ip->get_token(1) == "Update_SUN" ) {
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove "    var(i) = x"  (Make sure  that var does not occur as first token anywhere else)
+
+    if(ip->get_token(0) == "VAR") {
       lo_line.insert(0,"!DELETE ");
     cout << lo_line << endl;
@@ -338,4 +329,93 @@
     }
 
+//  Remove  REAL(kind=dp):: sun
+
+    if(ip->get_token_number_from_string("SUN") > 0) {
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    INTEGER :: ddmtype
+
+    if(ip->get_token_number_from_string("DDMTYPE") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    REAL(kind=dp) :: dt
+
+    if(ip->get_token_number_from_string("DT") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    LOOKAT
+
+    if(ip->get_token_number_from_string("LOOKAT") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    NLOOKAT
+
+    if(ip->get_token_number_from_string("NLOOKAT") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    MONITOR
+
+    if(ip->get_token_number_from_string("MONITOR") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    NMONITOR
+
+    if(ip->get_token_number_from_string("NMONITOR") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    SMASS
+
+    if(ip->get_token_number_from_string("SMASS") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    RTOLS
+
+    if(ip->get_token_number_from_string("RTOLS") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    TEND
+
+    if(ip->get_token_number_from_string("TEND") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+//  Remove    STEPMAX
+
+    if(ip->get_token_number_from_string("STEPMAX") > 0) {
+    cout << lo_line << endl;
+      lo_line.insert(0,"!DELETE ");
+    cout << lo_line << endl;
+    }
+
+
+
 //  Make ind_ variables public
     if(ip->get_token(3).substr(0,4) == "ind_") {
@@ -464,8 +544,16 @@
        to_do = false;
     }
-    if(ip->get_token(0).substr(0,1) != "!" && ip->get_token_number_from_string("temp") > 2) {
-//  if(ip->get_token(0).substr(0,1) != "!" && ip->get_token_number_from_string("XXXX") > 2) {
-      todo_1 = true;
-    }
+    if(kpp_switches.is_vector()) {
+       if(ip->get_token(0).substr(0,1) != "!" && ip->get_token_number_from_string("TEMP") > 2) {
+         todo_1 = true;
+       }
+       if(ip->get_token(0).substr(0,1) != "!" && ip->get_token_number_from_string("QVAP") > 2) {
+         todo_1 = true;
+       }
+       if(ip->get_token(0).substr(0,1) != "!" && ip->get_token_number_from_string("FAKT") > 2) {
+         todo_1 = true;
+       }
+    }
+
     if(to_do || todo_1) {
       if(ip->get_token(0).substr(0,1) == "!") continue;       // skip comment limes
@@ -499,19 +587,24 @@
       cout << "Vector variable " << ip->get_token(pos+1) <<" " << vari.nr_dim() <<endl;
       lo_line = ip->get_line() ;
-      if(vari.nr_dim() == 0) {
-        lo_line.clear();
-        lo_line = "  REAL(dp),dimension(:),allocatable             :: " + vari.name;
-      }
-      if(vari.nr_dim() == 1) {
-        lo_line.clear();
-        lo_line = "  REAL(dp),dimension(:,:),allocatable           :: " + vari.name;
-      }
-      if(vari.nr_dim() == 2) {
-        lo_line.clear();
-        lo_line = "  REAL(dp),dimension(:,:,:),allocatable         :: " + vari.name;
-      }
-      if(vari.nr_dim() == 3) {
-        lo_line.clear();
-        lo_line = "  REAL(dp),dimension(:,:,:,:),allocatable       :: " + vari.name;
+      if(todo_1)   {
+          lo_line.clear();
+          lo_line = "  REAL(dp),dimension(VL_DIM)                  :: " + vari.name;
+      } else {
+         if(vari.nr_dim() == 0) {
+           lo_line.clear();
+           lo_line = "  REAL(dp),dimension(:),allocatable             :: " + vari.name;
+         }
+         if(vari.nr_dim() == 1) {
+           lo_line.clear();
+           lo_line = "  REAL(dp),dimension(:,:),allocatable           :: " + vari.name;
+         }
+         if(vari.nr_dim() == 2) {
+           lo_line.clear();
+           lo_line = "  REAL(dp),dimension(:,:,:),allocatable         :: " + vari.name;
+         }
+         if(vari.nr_dim() == 3) {
+           lo_line.clear();
+           lo_line = "  REAL(dp),dimension(:,:,:,:),allocatable       :: " + vari.name;
+         }
       }
       ip->set_line(lo_line);
@@ -541,5 +634,7 @@
 
   vector<program_line>::iterator     ip;
+  program_line                    pl;
   string                             lo_line;
+  string                             line;
 
   for (ip=pline.begin(); ip != pline.end(); ip++) {
@@ -555,6 +650,6 @@
     ip->global_substitute("* ","*");
     ip->global_substitute("* ","*");
-    ip->global_substitute("d- ","d-");
-    ip->global_substitute("d+ ","d+");
+//  ip->global_substitute("d- ","d-");
+//  ip->global_substitute("d+ ","d+");
     ip->global_substitute(", ",",");
     ip->global_substitute(")=",") =");
@@ -562,9 +657,108 @@
     ip->global_substitute(", - ",", -");
 
+// Now do some cosmetics to adapt the KPP generated output a bit o the looks of PALM, 
+// i.e. add some blanks, convert all to lowercase except Fortran language elements, etc.
+//  Replace Roundoff = WLAMCH('E') by Roundoff = epsilon(one)
+       ip->global_substitute("Roundoff = WLAMCH('E')","roundoff = epsilon(one)");
+       lo_line = ip->get_line();
+       if(lo_line.find("'",0) == string::npos)  {     // No substitution in line with strings
+        if(lo_line.substr(0,2) =="! ") {
+         ip->global_substitute("#","#");      // just a dummy so comments do not get lost
+         } else {
+//       cout << "HIER0 " << lo_line <<endl;
+//       global_substitute(lo_line,"("," ( ");
+//       global_substitute(lo_line,")"," ) ");
+         global_substitute(lo_line,",",", ");
+         global_substitute(lo_line,",  ",", ");
+         global_substitute(lo_line,")  ",") ");
+         global_substitute(lo_line,"*","* ");
+         global_substitute(lo_line,"* *","**");
+         global_substitute(lo_line,")+",") +");
+         global_substitute(lo_line,")-",") -");
+         global_substitute(lo_line,")/",") /");
+         global_substitute(lo_line,")*",") *");
+         global_substitute(lo_line,")=",") =");
+//       global_substitute(lo_line,"-","- ");
+         global_substitute(lo_line,"-  ","- ");
+         global_substitute(lo_line,"+","+ ");
+         global_substitute(lo_line,"+  ","+ ");
+         global_substitute(lo_line,"=- ","= -");
+         global_substitute(lo_line,"/JVS","/ JVS");
+         global_substitute(lo_line,"d- ","d-");
+         global_substitute(lo_line,"d+ ","d+");
+         global_substitute(lo_line,"D- ","D-");
+         global_substitute(lo_line,"D+ ","D+");
+         global_substitute(lo_line,"e- ","e-");
+         global_substitute(lo_line,"e+ ","e+");
+         global_substitute(lo_line,"E+ ","E+");
+         global_substitute(lo_line,"E- ","E-");
+         ip->global_subtolower(lo_line);
+         global_substitute(lo_line,"allocated","ALLOCATED");
+         global_substitute(lo_line,"allocatable","ALLOCATABLE");
+         global_substitute(lo_line,".and. ",".AND. ");
+         global_substitute(lo_line,"call ","CALL ");
+         global_substitute(lo_line,"case","CASE");
+         global_substitute(lo_line,"character","CHARACTER");
+         global_substitute(lo_line,"contains","CONTAINS");
+         global_substitute(lo_line,"deallocate","DEALLOCATE");
+         global_substitute(lo_line,"allocate","ALLOCATE");
+         global_substitute(lo_line,"dimension","DIMENSION");
+         global_substitute(lo_line,"do ","DO ");
+         global_substitute(lo_line,"elseif","ELSEIF");
+         global_substitute(lo_line,"else","ELSE");
+         global_substitute(lo_line,"#ELSE","#else");
+         global_substitute(lo_line,"end do","ENDDO");
+         global_substitute(lo_line,"end if","ENDIF");
+         global_substitute(lo_line,"endif","ENDIF");
+         global_substitute(lo_line,"endwhere","ENDWHERE");
+         global_substitute(lo_line,"end ","END ");    // Modify "end" after all other strings containing "end..." are done!
+         global_substitute(lo_line,"tEND","tend");
+         global_substitute(lo_line,"#ENDIF","#endif");
+         global_substitute(lo_line,"equivalence","EQUIVALENCE");
+         global_substitute(lo_line,"function","FUNCTION");
+         global_substitute(lo_line,"if(","IF (");
+         global_substitute(lo_line," if "," IF ");
+         global_substitute(lo_line,"implicit","IMPLICIT");
+         global_substitute(lo_line,"include","INCLUDE");
+         global_substitute(lo_line,"intent","INTENT");
+         global_substitute(lo_line,"integer","INTEGER");
+         global_substitute(lo_line,"interface","INTERFACE");
+         global_substitute(lo_line,"logical","LOGICAL");
+         global_substitute(lo_line,"module","MODULE");
+         global_substitute(lo_line,"none","NONE");
+         global_substitute(lo_line,"only","ONLY");
+         global_substitute(lo_line,"optional","OPTIONAL");
+         global_substitute(lo_line,"parameter","PARAMETER");
+         global_substitute(lo_line,"present","PRESENT");
+         global_substitute(lo_line,"private","PRIVATE");
+         global_substitute(lo_line,"procedure","PROCEDURE");
+         global_substitute(lo_line,"public","PUBLIC");
+         global_substitute(lo_line,"real","REAL");
+         global_substitute(lo_line,"return","RETURN");
+         global_substitute(lo_line,"use ","USE ");
+         global_substitute(lo_line,"save","SAVE");
+         global_substitute(lo_line,"subroutine","SUBROUTINE");
+         global_substitute(lo_line,"then","THEN");
+         global_substitute(lo_line,"where","WHERE");
+         global_substitute(lo_line,"while","WHILE");
+         global_substitute(lo_line,".false.",".FALSE.");
+         global_substitute(lo_line,".true.",".TRUE.");
+         global_substitute(lo_line,"(in)","(IN)");
+         global_substitute(lo_line,"(out)","(OUT)");
+         global_substitute(lo_line,"(inout)","(INOUT)");
+         global_substitute(lo_line,"\t","      ");
+//       cout << "HIER1 " << lo_line <<endl;
+       }
+     }
+//   pl.set_line(lo_line);
+//   pline.push_back(pl);
+
+
 //  line break if more than 130 character
 
-    lo_line = ip->get_line();
+//  lo_line = ip->get_line();
     if( lo_line.size() < 130 ) {
-      out << ip->get_line() <<endl;
+//    out << ip->get_line() <<endl;
+      out <<  lo_line    <<endl;
     } else {
       int cp  = lo_line.rfind("!",129);
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.h
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.h	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file.h	(revision 3298)
@@ -12,6 +12,16 @@
 // ############################################################################
 //
-//  Modifications:
-//    RFo added global_subtolower
+//Current revisions:
+//------------------
+/ 
+/ 
+//Former revisions:
+//-----------------
+// Nov 2016: Intial version of KP4 adapted to PALM (Klaus Ketelsen)
+//  forkel Sept.2018:  added edit_Initialize
+//  forkel          :  added global_subtolower
+//
+/ Intial version of KP4
+
 
 #include <iostream>
@@ -42,6 +52,10 @@
   void edit_KppSolve () ;
   void edit_Fun () ;
+  void edit_WAXPY () ;
+  void edit_FunTemplate () ;
+  void edit_JacTemplate () ;
   void edit_FUNC () ;
   void edit_Update_RCONST (vector <Vvar> &var_list) ;
+  void edit_Initialize (vector <Vvar> &var_list) ;
   void edit_inc (fortran_file & header_var) ;
   void create_species_list(vector <string> &species_list);
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file_vec.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file_vec.C	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/fortran_file_vec.C	(revision 3298)
@@ -9,4 +9,21 @@
 //
 // ############################################################################
+//Current revisions:
+//------------------
+/ 
+/ 
+//Former revisions:
+//-----------------
+//$Id: fortran_file.C 2470 2017-09-14 13:56:42Z forkel $
+//  ketelsen 18.09.2018: Line 112: do k=is,ie bydo k=1,vl; line 156 ff: replaced index k by j
+//
+//  forkel Sept.2018:  added edit_Initialize
+//                     changed loop direction for update_rconst in edit_Update_RCONST
+/ 2017-09-14 13:56:42Z forkel $
+//
+//
+// Nov 2016: Intial version of KP4 adapted to PALM (Klaus Ketelsen)
+//
+
 
 #include <fstream>
@@ -77,8 +94,19 @@
     }
   }
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+      if(kpp_switches.is_vector() ) {
+    	  ip->global_substitute ("phot (","phot(j,");
+      }
+  }
+
   ip = pline.begin()+1 ;
   lo_line = ip->get_line() ;
   lo_line.erase();
-  lo_line = " INTEGER         :: j,k";
+  if(kpp_switches.is_vector() ) {
+    lo_line = " INTEGER         :: j,k";
+  } else {
+    lo_line = " INTEGER         :: k";
+  }
   ip->set_line(lo_line);
   
@@ -87,5 +115,5 @@
     lo_line = ip->get_line() ;
     lo_line.erase();
-    lo_line = " do k=is,ie";
+    lo_line = " do k=1,vl";
     ip->set_line(lo_line);
 
@@ -93,5 +121,5 @@
     lo_line = ip->get_line() ;
     lo_line.erase();
-    lo_line = "  j = k-is+1";
+    lo_line = "  j = k";
     ip->set_line(lo_line);
 
@@ -103,4 +131,68 @@
   } else {
     ip = pline.begin()+3 ;
+    lo_line = ip->get_line() ;
+    lo_line.erase();
+    lo_line = "  k = is";
+    ip->set_line(lo_line);
+  }
+
+  return;
+}
+
+void fortran_file::edit_Initialize (vector <Vvar> &var_list) {
+  vector<program_line>::iterator     ip;
+  vector<Vvar>::iterator             iv;
+  string                             lo_line;
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+    ip->global_substitute ("*"," *");
+    ip->global_substitute ("* *","**");
+    ip->global_substitute (","," , ");
+    ip->global_substitute ("/"," / ");
+    ip->global_substitute ("1:VL","j");
+  }
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+    for (iv=var_list.begin(); iv != var_list.end(); iv++) {
+      ip->change_variable_to_vector_g (*iv);
+    }
+  }
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+    if(kpp_switches.is_vector() ) {
+          ip->global_substitute ("qvap","qvap(j)");
+    }
+  }
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+    if(kpp_switches.is_vector() ) {
+          ip->global_substitute ("fakt","fakt(j)");
+    }
+  }
+
+  ip = pline.begin()+3 ;
+  lo_line = ip->get_line() ;
+  lo_line.erase();
+  lo_line = "  INTEGER         :: j,k";
+  ip->set_line(lo_line);
+
+  if(kpp_switches.is_vector() ) {
+    ip = pline.begin()+9 ;
+    lo_line = ip->get_line() ;
+    lo_line.erase();
+    lo_line = " do k = is,ie";
+    ip->set_line(lo_line);
+
+    ip = pline.begin()+10 ;
+    lo_line = ip->get_line() ;
+    lo_line.erase();
+    lo_line = "  j = k - is +1";
+    ip->set_line(lo_line);
+
+    ip = pline.end()-2 ;
+    lo_line = ip->get_line() ;
+//  lo_line.erase();
+    lo_line = " end do";
+    ip->set_line(lo_line);
+  } else {
+    ip = pline.begin()+7 ;
     lo_line = ip->get_line() ;
     lo_line.erase();
@@ -236,2 +328,73 @@
 }
 
+void fortran_file::edit_WAXPY () {
+
+  vector<program_line>::iterator     ip;
+
+  cout << "Handling subroutine: WAXPY" <<endl;
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+
+    if(ip->get_token(0) == "REAL") {
+       ip->substitute("N",":,:");
+       ip->substitute("N",":,:");
+       ip->substitute("Alpha","Alpha(:)");
+    } else {
+        ip->change_variable_to_vector ("Y");
+        ip->change_variable_to_vector ("X");
+        if(ip->get_token(0) != "SUBROUTINE") {
+        	if(ip->get_token(0) == "IF")  {
+        		ip->substitute("Alpha","SUM(alpha(1:VL))");
+        	} else {
+        		ip->substitute("Alpha","alpha(1:VL)");
+        	}
+        }
+    }
+
+
+  }
+
+  return;
+}
+
+void fortran_file::edit_FunTemplate () {
+
+  vector<program_line>::iterator     ip;
+
+  cout << "Handling subroutine: FunTemplate" <<endl;
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+
+    if(ip->get_token(0) == "REAL") {
+       ip->substitute("NVAR",":,:");
+       ip->substitute("T,","T(:),");
+       ip->substitute("Told","Told(size(T)),Time(size(T))");
+    }
+
+
+  }
+
+  return;
+}
+
+void fortran_file::edit_JacTemplate () {
+
+  vector<program_line>::iterator     ip;
+
+  cout << "Handling subroutine: JacTemplate" <<endl;
+
+  for (ip=pline.begin(); ip != pline.end(); ip++) {
+
+    if(ip->get_token(0) == "REAL") {
+        ip->substitute("NVAR",":,:");
+        ip->substitute("T,","T(:),");
+        ip->substitute("Told","Told(size(T)),Time(size(T))");
+        ip->substitute("LU_NONZERO",":,:");
+    }
+
+
+  }
+
+  return;
+}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.C	(revision 3298)
@@ -134,3 +134,17 @@
   return;
 }
+void   program_line::global_subtolower(string &line) {
 
+   int start = line.size()-1;
+   char c;
+
+    int i = 0;
+    while (line[i])
+    {
+      c = line[i];
+      line[i] = tolower(c);
+      i++;
+    }
+   return;
+}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/program_line.h	(revision 3298)
@@ -11,4 +11,6 @@
 //
 // ############################################################################
+//
+// forkel June 2018: added    void   global_subtolower(string &line);
 
 #include <iostream>
@@ -42,4 +44,5 @@
    void   change_variable_to_vector    (string var);
    void   change_variable_to_vector_g  (Vvar  &var);
+   void   global_subtolower(string &line);
 };
 
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/cbm4.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/cbm4.eqn	(revision 3298)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/cbm4.eqn	(revision 3298)
@@ -0,0 +1,113 @@
+#EQUATIONS {CBM4}
+
+{01:J01} NO2+hv=NO+O                          :  phot(j_no2)  ;
+{02:J02} O3+hv=O                              :  phot(j_o33p) ;
+{03:J03} O3+hv=O1D_CB4                        :  phot(j_o31d) ;
+{04:J04} NO3+hv=0.89 NO2+0.89 O+0.11 NO       :  phot(j_no3o)+phot(j_no3o2);
+{05:J05} HONO+hv=HO+NO                        :  phot(j_hono) ;
+{06:J06} H2O2+hv=2 HO                         :  phot(j_h2o2) ; 
+{07:J07} HCHO+hv{+2 O2}= 2 HO2+CO             :  phot(j_ch2or) ;
+{08:J08} HCHO+hv=CO                           :  phot(j_ch2om) ;
+{09:J09} ALD2+hv{+ 2 O2}=HCHO+XO2+CO+ 2 HO2   :  4.6E-4_dp*phot(j_no2) ; 
+{10:J10} OPEN+hv=C2O3+CO+HO2                  :  9.04_dp*phot(j_ch2or) ; 
+{11:J11} MGLY+hv=C2O3+CO+HO2                  :  9.64_dp*phot(j_ch2or) ; 
+{12:01} O{+O2+M}=O3                           :  arr2(1.4E+3_dp, -1175.0_dp, temp) ;
+{13:02} O3+NO=NO2                             :  arr2(1.8E-12_dp, +1370.0_dp, temp) ;
+{14:03} O+NO2=NO                              :  9.3E-12_dp ;
+{15:04} O+NO2=NO3                             :  arr2(1.6E-13_dp, -687.0_dp, temp) ;
+{16:05} O+NO=NO2                              :  arr2(2.2E-13_dp, -602.0_dp, temp) ;
+{17:06} O3+NO2=NO3                            :  arr2(1.2E-13_dp, +2450.0_dp, temp) ;
+{18:07} O1D_CB4=O                             :  arr2(1.9E+8_dp, -390.0_dp, temp)  ;
+{19:08} O1D_CB4+H2O=2HO                       :  2.2E-10_dp ;
+{20:09} O3+HO=HO2                             :  arr2(1.6E-12_dp, +940.0_dp, temp) ;
+{21:10} O3+HO2=HO                             :  arr2(1.4E-14_dp, +580.0_dp, temp) ;
+{22:11} NO3+NO=2 NO2                          :  arr2(1.3E-11_dp, -250.0_dp, temp) ;
+{23:12} NO3+NO2=NO+NO2                        :  arr2(2.5E-14_dp, +1230.0_dp, temp) ;
+{24:13} NO3+NO2=N2O5                          :  arr2(5.3E-13_dp, -256.0_dp, temp) ;
+{25:14} N2O5+H2O=2 HNO3                       :  1.3E-21_dp ;
+{26:15} N2O5=NO3+NO2                          :  arr2(3.5E+14_dp, +10897.0_dp, temp) ;
+{27:16} 2 NO=2 NO2                            :  arr2(1.8E-20_dp, -530.0_dp, temp) ;
+{28:17} NO+NO2+H2O=2 HONO                     :  4.4E-40_dp ;
+{29:18} HO+NO=HONO                            :  arr2(4.5E-13_dp, -806.0_dp, temp) ;
+{30:19} HO+HONO=NO2                           :  6.6E-12_dp ;
+{31:20} 2 HONO=NO+NO2                         :  1.0E-20_dp ;
+{32:21} HO+NO2=HNO3                           :  arr2(1.0E-12_dp, -713.0_dp, temp) ;
+{33:22} HO+HNO3=NO3                           :  arr2(5.1E-15_dp, -1000.0_dp, temp) ;
+{34:23} HO2+NO=HO+NO2                         :  arr2(3.7E-12_dp, -240.0_dp, temp) ;
+{35:24} HO2+NO2=PNA                           :  arr2(1.2E-13_dp, -749.0_dp, temp) ;
+{36:25} PNA=HO2+NO2                           :  arr2(4.8E+13_dp, +10121.0_dp, temp) ;
+{37:26} HO+PNA=NO2                            :  arr2(1.3E-12_dp, -380.0_dp, temp) ;
+{38:27} 2 HO2=H2O2                            :  arr2(5.9E-14_dp, -1150.0_dp, temp)  ;
+{39:28} 2 HO2+H2O=H2O2                        :  arr2(2.2E-38_dp, -5800.0_dp, temp) ;
+{40:29} HO+H2O2=HO2                           :  arr2(3.1E-12_dp, +187.0_dp, temp) ;
+{41:30} HO+CO=HO2                             :  2.2E-13_dp ;
+{42:31} HCHO+HO=HO2+CO                        :  1.0E-11_dp ;
+{43:32} HCHO+O=HO+HO2+CO                      :  arr2(3.0E-11_dp, +1550.0_dp, temp) ;
+{44:33} HCHO+NO3=HNO3+HO2+CO                  :  6.3E-16_dp ;
+{45:34} ALD2+O=C2O3+HO                        :  arr2(1.2E-11_dp, +986.0_dp, temp) ;
+{46:35} ALD2+HO=C2O3                          :  arr2(7.0E-12_dp, -250.0_dp, temp) ;
+{47:36} ALD2+NO3=C2O3+HNO3                    :  2.5E-15_dp  ;
+{48:37} C2O3+NO=HCHO+XO2+HO2+NO2              :  arr2(5.4E-12_dp, -250.0_dp, temp) ;
+{49:38} C2O3+NO2=PAN                          :  arr2(8.0E-20_dp, -5500.0_dp, temp) ;
+{50:39} PAN=C2O3+NO2                          :  arr2(9.4E+16_dp, +14000.0_dp, temp) ;
+{51:40} 2 C2O3=2 HCHO+2 XO2+2 HO2             :  2.0E-12_dp  ;
+{52:41} C2O3+HO2=0.79 HCHO+0.79 XO2
+                +0.79 HO2+0.79 HO             :  6.5E-12_dp ;
+{53:42} HO=HCHO+XO2+HO2                       :  arr2(1.1E+2_dp, +1710.0_dp, temp) ;
+{54:43} PAR+HO=0.87 XO2+0.13 XO2N
+              +0.11 HO2+0.11 ALD2
+              +0.76 ROR-0.11 PAR              :  8.1E-13_dp ;
+{55:44} ROR=1.1 ALD2+0.96 XO2
+           +0.94 HO2 +0.04 XO2N
+           +0.02 ROR-2.10 PAR                 :  arr2(1.0E+15_dp, +8000.0_dp, temp) ;
+{56:45} ROR=HO2                               :  1.6E+03_dp ;
+{57:46} ROR+NO2= PROD                         :  1.5E-11_dp  ;
+{58:47} O+OLE=0.63 ALD2+0.38 HO2
+             +0.28 XO2+0.3 CO
+             +0.2 HCHO+0.02 XO2N
+             +0.22 PAR+0.2 HO                 :  arr2(1.2E-11_dp, +324.0_dp, temp) ;
+{59:48} HO+OLE=HCHO+ALD2+XO2+HO2-PAR          :  arr2(5.2E-12_dp, -504.0_dp, temp) ;
+{60:49} O3+OLE=0.5 ALD2+0.74 HCHO
+              +0.33 CO+0.44 HO2
+              +0.22 XO2+0.1 HO-PAR            :  arr2(1.4E-14_dp, +2105.0_dp, temp)  ;
+{61:50} NO3+OLE=0.91 XO2+HCHO
+               +ALD2+0.09 XO2N
+               +NO2-PAR                       :  7.7E-15_dp ;
+{62:51} O+ETH=HCHO+0.7 XO2
+             +CO+1.7 HO2+0.3 HO               :  arr2(1.0E-11_dp, +792.0_dp, temp) ;
+{63:52} HO+ETH=XO2+1.56 HCHO
+              +HO2+0.22 ALD2                  :  arr2(2.0E-12_dp, -411.0_dp, temp) ;
+{64:53} O3+ETH=HCHO+0.42 CO+0.12 HO2          :  arr2(1.3E-14_dp, +2633.0_dp, temp) ;
+{65:54} HO+TOL=0.08 XO2+0.36 CRES
+              +0.44 HO2+0.56 TO2              :  arr2(2.1E-12_dp, -322.0_dp, temp) ;
+{66:55} TO2+NO=0.9 NO2+0.9 OPEN+0.9 HO2       :  8.1E-12_dp ;
+{67:56} TO2=HO2+CRES                          :  4.20_dp ;
+{68:57} HO+CRES=0.4 CRO+0.6 XO2
+               +0.6 HO2+0.3 OPEN              :  4.1E-11_dp  ;
+{69:58} NO3+CRES=CRO+HNO3                     :  2.2E-11_dp ;
+{70:59} CRO+NO2=PROD                          :  1.4E-11_dp ;
+{71:60} HO+XYL=0.7 HO2+0.5 XO2
+              +0.2 CRES+0.8 MGLY
+              +1.10 PAR+0.3 TO2               :  arr2(1.7E-11_dp, -116.0_dp, temp) ;
+{72:61} HO+OPEN=XO2+C2O3+2 HO2+2 CO+HCHO      :  3.0E-11_dp ;
+{73:62} O3+OPEN=0.03 ALD2+0.62 C2O3
+               +0.7 HCHO+0.03 XO2
+               +0.69 CO+0.08 HO
+               +0.76 HO2+0.2 MGLY             :  arr2(5.4E-17_dp, +500.0_dp, temp)  ;
+{74:63} HO+MGLY=XO2+C2O3                      :  1.70E-11_dp ;
+{75:64} O+ISOP=0.6 HO2+0.8 ALD2
+              +0.55 OLE+0.5 XO2
+              +0.5 CO+0.45 ETH
+              +0.9 PAR                        :  1.80E-11_dp  ;
+{76:65} HO+ISOP=HCHO+XO2
+               +0.67 HO2+0.4 MGLY
+               +0.2 C2O3+ETH
+               +0.2 ALD2+0.13 XO2N            :  9.6E-11_dp  ;
+{77:66} O3+ISOP=HCHO+0.4 ALD2
+               +0.55 ETH+0.2 MGLY
+               +0.06 CO+0.1 PAR
+               +0.44 HO2+0.1 HO               :  1.2E-17_dp ;
+{78:67} NO3+ISOP=XO2N                         :  3.2E-13_dp ;
+{79:68} XO2+NO=NO2                            :  8.1E-12_dp ;
+{80:69} 2 XO2=PROD                            :  arr2(1.7E-14_dp, -1300.0_dp, temp) ;
+{81:70} XO2N+NO=PROD                          :  6.8E-13_dp ;
